unit DlgFind;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, JvRichEdit, AppEvnts;

type
  TFindDlg = class(TForm)
    EditFindText: TEdit;
    Label1: TLabel;
    CheckBoxWholeWord: TCheckBox;
    CheckBoxMatchCase: TCheckBox;
    ButtonNext: TButton;
    ButtonCancel: TButton;
    CheckBoxDocument: TCheckBox;
    ApplicationEvents: TApplicationEvents;
    ButtonPrev: TButton;
    procedure ButtonNextClick(Sender: TObject);
    procedure ApplicationEventsIdle(Sender: TObject; var Done: Boolean);
    procedure ButtonPrevClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Private 錾 }
    procedure SetFindParam;
  public
    { Public 錾 }
    FindText: String;
    SearchTypes: TRichSearchTypes;
  end;

var
  FindDlg: TFindDlg;

implementation

{$R *.dfm}


//----------------------------------------
// p[^Zbg
//----------------------------------------
procedure TFindDlg.SetFindParam;
begin
  // ݒ
  FindText := EditFindText.Text;

  // PPʂŒT
  if CheckBoxWholeWord.Checked then
  begin
    SearchTypes := SearchTypes + [stWholeWord];
  end
  else
  begin
    SearchTypes := SearchTypes - [stWholeWord];
  end;

  // 啶Əʂ
  if CheckBoxMatchCase.Checked then
  begin
    SearchTypes := SearchTypes + [stMatchCase];
  end
  else
  begin
    SearchTypes := SearchTypes - [stMatchCase];
  end;
end;


//----------------------------------------
// O{^NbNCxg
//----------------------------------------
procedure TFindDlg.ButtonPrevClick(Sender: TObject);
begin
  SetFindParam;
  SearchTypes := SearchTypes + [stBackward];
end;


//----------------------------------------
// {^NbNCxg
//----------------------------------------
procedure TFindDlg.ButtonNextClick(Sender: TObject);
begin
  SetFindParam;
  SearchTypes := SearchTypes - [stBackward];
end;


//----------------------------------------
// Idlȅ
//----------------------------------------
procedure TFindDlg.ApplicationEventsIdle(Sender: TObject;
  var Done: Boolean);
begin
  ButtonPrev.Enabled := EditFindText.Text <> '';
  ButtonNext.Enabled := EditFindText.Text <> '';
end;


//----------------------------------------
// \Cxg
//----------------------------------------
procedure TFindDlg.FormActivate(Sender: TObject);
begin
  EditFindText.SetFocus;
  EditFindText.Text := FindText;
end;


end.
