unit DlgKeyBind;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, ActnList, StdCtrls, VirtualTrees, ImgList, JvComponent,
  JvAppStorage, JvAppIniStorage, JvComponentBase;

type
  // m[hf[^
  PBindData = ^TBindData;
  TBindData = record
    Caption: String;
    Action: String;
    ImageIndex: Integer;
    Shortcut: String;
  end;

  TKeyBindDlg = class(TForm)
    ButtonOK: TButton;
    ButtonCancel: TButton;
    ActionTreeView: TVirtualStringTree;
    TreeImageList: TImageList;
    procedure ActionTreeViewGetNodeDataSize(Sender: TBaseVirtualTree;
      var NodeDataSize: Integer);
    procedure ActionTreeViewGetText(Sender: TBaseVirtualTree;
      Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType;
      var CellText: WideString);
    procedure ActionTreeViewGetImageIndex(Sender: TBaseVirtualTree;
      Node: PVirtualNode; Kind: TVTImageKind; Column: TColumnIndex;
      var Ghosted: Boolean; var ImageIndex: Integer);
    procedure FormCreate(Sender: TObject);
    procedure ActionTreeViewDblClick(Sender: TObject);
    procedure ActionTreeViewKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ButtonOKClick(Sender: TObject);
    procedure ActionTreeViewFreeNode(Sender: TBaseVirtualTree;
      Node: PVirtualNode);
    procedure FormDestroy(Sender: TObject);
    procedure ActionTreeViewInitNode(Sender: TBaseVirtualTree; ParentNode,
      Node: PVirtualNode; var InitialStates: TVirtualNodeInitStates);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  KeyBindDlg: TKeyBindDlg;

implementation

uses FormMain, DlgInputKey, FormTree, FormEditor, ModuleGlobal;

{$R *.dfm}


//----------------------------------------
// m[h̃f[^TCYKvɂȂƂɌĂяo
//----------------------------------------
procedure TKeyBindDlg.ActionTreeViewGetNodeDataSize(Sender: TBaseVirtualTree;
  var NodeDataSize: Integer);
begin
  NodeDataSize := SizeOf(TBindData);
end;


//----------------------------------------
// m[h̃eLXgKvɂȂƂɌĂяo
//----------------------------------------
procedure TKeyBindDlg.ActionTreeViewGetText(Sender: TBaseVirtualTree;
  Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType;
  var CellText: WideString);
var
  Data: PBindData;
begin
  if TextType = ttNormal then
  begin
    if Column = 0 then
    begin
      Data := Sender.GetNodeData(Node);
      CellText := Data.Caption;
    end;
    if Column = 1 then
    begin
      Data := Sender.GetNodeData(Node);
      CellText := Data.Shortcut;
    end;
  end
  else
  begin
    CellText := '';
  end;
end;


//----------------------------------------
// m[h̃C[WԍKvɂȂƂɌĂяo
//----------------------------------------
procedure TKeyBindDlg.ActionTreeViewGetImageIndex(Sender: TBaseVirtualTree;
  Node: PVirtualNode; Kind: TVTImageKind; Column: TColumnIndex;
  var Ghosted: Boolean; var ImageIndex: Integer);
var
  Data: PBindData;
begin
  // m[hɎqꍇ́AtH_̃C[W
  if Column = 0 then
  begin
    if Node.ChildCount > 0 then
    begin
      if Sender.Expanded[Node] then
      begin
        ImageIndex := 2;
        //ImageIndex := -1;
      end
      else
      begin
        ImageIndex := 1;
        //ImageIndex := -1;
      end;
    end
    // ANṼC[W
    else
    begin
      Data := Sender.GetNodeData(Node);
      ImageIndex := Data.ImageIndex;
    end;
  end;
end;


//----------------------------------------
// tH[̏
//----------------------------------------
procedure TKeyBindDlg.FormCreate(Sender: TObject);
var
  ParentNode: PVirtualNode;
  //Node: PVirtualNode;
  ParentData: PBindData;

  procedure SetNode(Node: PVirtualNode; Action: TAction; ImageIndex: Integer);
  var
    Data: PBindData;
  begin
    Data := ActionTreeView.GetNodeData(Node);
    Data.Caption := Copy(Action.Caption, 0, Pos('(', Action.Caption)-1);
    Data.Action := Action.Name;
    Data.ImageIndex := ImageIndex;
    Data.Shortcut := ShortCutToText(Action.ShortCut);
    ActionTreeView.Text[Node, 0] := Data.Caption;
  end;

begin
  // t@C
  begin
    // e
    ParentNode := ActionTreeView.AddChild(nil);
    ParentData := ActionTreeView.GetNodeData(ParentNode);
    ParentData.Caption := 't@C';
    // VK쐬
    SetNode(ActionTreeView.AddChild(ParentNode), MainForm.ActionNew, 3);
    // J
    SetNode(ActionTreeView.AddChild(ParentNode), MainForm.ActionOpen, 4);
    // ㏑ۑ
    SetNode(ActionTreeView.AddChild(ParentNode), MainForm.ActionSave, 5);
    // Oĕۑ
    SetNode(ActionTreeView.AddChild(ParentNode), MainForm.ActionSaveAs, 6);
    // y[WGNX|[g
    SetNode(ActionTreeView.AddChild(ParentNode), MainForm.ActionExportPage, -1);
    // GNX|[g
    SetNode(ActionTreeView.AddChild(ParentNode), MainForm.ActionExportDoc, -1);
    // y[Wvg
    SetNode(ActionTreeView.AddChild(ParentNode), MainForm.ActionPagePrint, 46);
    // vg
    SetNode(ActionTreeView.AddChild(ParentNode), MainForm.ActionDocPrint, 46);
    // I
    SetNode(ActionTreeView.AddChild(ParentNode), MainForm.ActionExit, -1);
  end;

  // ړ
  begin
    // e
    ParentNode := ActionTreeView.AddChild(nil);
    ParentData := ActionTreeView.GetNodeData(ParentNode);
    ParentData.Caption := 'ړ';
    // ߂
    SetNode(ActionTreeView.AddChild(ParentNode), MainForm.ActionNaviPrev, 7);
    // i
    SetNode(ActionTreeView.AddChild(ParentNode), MainForm.ActionNaviNext, 8);
    // O
    SetNode(ActionTreeView.AddChild(ParentNode), TreeForm.ActionPrevFocus, -1);
    // 
    SetNode(ActionTreeView.AddChild(ParentNode), TreeForm.ActionNextFocus, -1);
  end;

  // c[
  begin
    // e
    ParentNode := ActionTreeView.AddChild(nil);
    ParentData := ActionTreeView.GetNodeData(ParentNode);
    ParentData.Caption := 'c[';
    // m[h}
    SetNode(ActionTreeView.AddChild(ParentNode), TreeForm.ActionInsertNode, 9);
    // m[hǉ
    SetNode(ActionTreeView.AddChild(ParentNode), TreeForm.ActionAddNode, 10);
    // qm[hǉ
    SetNode(ActionTreeView.AddChild(ParentNode), TreeForm.ActionAddChildNode, 11);
    // t@Cǉ
    SetNode(ActionTreeView.AddChild(ParentNode), MainForm.ActionAddFromFile, -1);
    // Oֈړ
    SetNode(ActionTreeView.AddChild(ParentNode), TreeForm.ActionMovePrev, 12);
    // ֈړ
    SetNode(ActionTreeView.AddChild(ParentNode), TreeForm.ActionMoveNext, 13);
    // ֈړ
    SetNode(ActionTreeView.AddChild(ParentNode), TreeForm.ActionMoveUp, 15);
    // ֈړ
    SetNode(ActionTreeView.AddChild(ParentNode), TreeForm.ActionMoveDown, 14);
{
    // m[hRs[
    SetNode(ActionTreeView.AddChild(ParentNode), TreeForm.ActionCopy, 16);
    // m[h؂
    SetNode(ActionTreeView.AddChild(ParentNode), TreeForm.ActionCut, 17);
    // m[h\t
    SetNode(ActionTreeView.AddChild(ParentNode), TreeForm.ActionPaste, 18);
}
    // m[h폜
    SetNode(ActionTreeView.AddChild(ParentNode), TreeForm.ActionDeteleNode, 19);
    // m[h
    SetNode(ActionTreeView.AddChild(ParentNode), MainForm.ActionTreeMergeNode, 20);
    // m[h
    SetNode(ActionTreeView.AddChild(ParentNode), MainForm.ActionTreeSplitNode, 21);
    // m[hȉSĊJ
    SetNode(ActionTreeView.AddChild(ParentNode), TreeForm.ActionExpandAll, 22);
    // \[g
    SetNode(ActionTreeView.AddChild(ParentNode), TreeForm.ActionSortNode, 43);
  end;

  // ҏW
  begin
    // e
    ParentNode := ActionTreeView.AddChild(nil);
    ParentData := ActionTreeView.GetNodeData(ParentNode);
    ParentData.Caption := 'ҏW';
    // ɖ߂
    SetNode(ActionTreeView.AddChild(ParentNode), EditorForm.ActionEditUndo, 23);
    // 蒼
    SetNode(ActionTreeView.AddChild(ParentNode), EditorForm.ActionEditRedo, 24);
    // Rs[
    SetNode(ActionTreeView.AddChild(ParentNode), MainForm.ActionCopy, 25);
    // ؂
    SetNode(ActionTreeView.AddChild(ParentNode), MainForm.ActionCut, 26);
    // \t
    SetNode(ActionTreeView.AddChild(ParentNode), MainForm.ActionPaste, 27);
    // `Iē\t
    SetNode(ActionTreeView.AddChild(ParentNode), MainForm.ActionFormatPaste, -1);
    // SđI
    SetNode(ActionTreeView.AddChild(ParentNode), MainForm.ActionSelectAll, -1);
  end;

  // 
  begin
    // e
    ParentNode := ActionTreeView.AddChild(nil);
    ParentData := ActionTreeView.GetNodeData(ParentNode);
    ParentData.Caption := '';
    // 
    SetNode(ActionTreeView.AddChild(ParentNode), MainForm.ActionFind, 28);
    SetNode(ActionTreeView.AddChild(ParentNode), MainForm.ActionFindPrev, -1);
    SetNode(ActionTreeView.AddChild(ParentNode), MainForm.ActionFindNext, -1);
    // u
    SetNode(ActionTreeView.AddChild(ParentNode), MainForm.ActionFindReplace, 29);
  end;

  // }
  begin
    // e
    ParentNode := ActionTreeView.AddChild(nil);
    ParentData := ActionTreeView.GetNodeData(ParentNode);
    ParentData.Caption := '}';
    // N
    SetNode(ActionTreeView.AddChild(ParentNode), EditorForm.ActionInsertLink, 30);
    // 摜
    SetNode(ActionTreeView.AddChild(ParentNode), EditorForm.ActionInsertPicture, 31);
    // IuWFNg
    SetNode(ActionTreeView.AddChild(ParentNode), EditorForm.ActionInsertObject, 32);
    // \
    SetNode(ActionTreeView.AddChild(ParentNode), EditorForm.ActionInsertTable, 44);
  end;

  // 
  begin
    // e
    ParentNode := ActionTreeView.AddChild(nil);
    ParentData := ActionTreeView.GetNodeData(ParentNode);
    ParentData.Caption := '';
    // tHg
    SetNode(ActionTreeView.AddChild(ParentNode), EditorForm.ActionFontDlg, -1);
    // {[h
    SetNode(ActionTreeView.AddChild(ParentNode), EditorForm.ActionBold, 33);
    // C^bN
    SetNode(ActionTreeView.AddChild(ParentNode), EditorForm.ActionItalic, 34);
    // 
    SetNode(ActionTreeView.AddChild(ParentNode), EditorForm.ActionUnderline, 35);
    // 
    SetNode(ActionTreeView.AddChild(ParentNode), EditorForm.ActionStrikeOut, 36);
    // t
    SetNode(ActionTreeView.AddChild(ParentNode), EditorForm.ActionSuperScript, 37);
    // t
    SetNode(ActionTreeView.AddChild(ParentNode), EditorForm.ActionSubScript, 38);
    // 
    SetNode(ActionTreeView.AddChild(ParentNode), EditorForm.ActionAlignLeft, 39);
    // 
    SetNode(ActionTreeView.AddChild(ParentNode), EditorForm.ActionAlignCenter, 40);
    // E
    SetNode(ActionTreeView.AddChild(ParentNode), EditorForm.ActionAlignRight, 41);
    // ӏ
    SetNode(ActionTreeView.AddChild(ParentNode), EditorForm.ActionBullets, 42);
    // ԍt
    SetNode(ActionTreeView.AddChild(ParentNode), EditorForm.ActionNumbering, 45);
  end;

end;


//----------------------------------------
// c[r[_uNbN
//----------------------------------------
procedure TKeyBindDlg.ActionTreeViewDblClick(Sender: TObject);
var
  Node: PVirtualNode;
  Data: PBindData;
  Dlg: TInputKeyDlg;
  ANode: PVirtualNode;
  AData: PBindData;
begin
  Node := ActionTreeView.FocusedNode;
  if Assigned(Node) and (Node.ChildCount = 0) then
  begin
    Dlg := TInputKeyDlg.Create(Self);
    try
      Data := ActionTreeView.GetNodeData(Node);
      Dlg.JvHotKey.HotKey := TextToShortCut(Data.Shortcut);
      if mrOK = Dlg.ShowModal then
      begin
        Data.Shortcut := ShortCutToText(Dlg.JvHotKey.HotKey);

        ANode := ActionTreeView.RootNode;
        ANode := ActionTreeView.GetFirstChild(ANode);
        while Assigned(ANode) do
        begin
          if Node <> ANode then
          begin
            AData := ActionTreeView.GetNodeData(ANode);
            if CompareText(Data.Shortcut, AData.Shortcut) = 0 then
            begin
              AData.Shortcut := '';
              Break;
            end;
          end;
          ANode := ActionTreeView.GetNext(ANode);
        end;

      end;
    finally
      Dlg.Release;
    end;
  end;
end;


//----------------------------------------
// c[r[L[͎
//----------------------------------------
procedure TKeyBindDlg.ActionTreeViewKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_RETURN then
  begin
    ActionTreeViewDblClick(Sender);
  end;
end;


//----------------------------------------
// OK{^NbN
//----------------------------------------
procedure TKeyBindDlg.ButtonOKClick(Sender: TObject);
var
  Node: PVirtualNode;
  Data: PBindData;
begin
  GlobalModule.IniStorage.Path := 'KeyBind';

  Node := ActionTreeView.RootNode;
  Node := ActionTreeView.GetFirstChild(Node);
  while Assigned(Node) do
  begin
    if Node.ChildCount =0 then
    begin
      Data := ActionTreeView.GetNodeData(Node);
      GlobalModule.IniStorage.WriteString(Data.Action, Data.Shortcut);
    end;
    Node := ActionTreeView.GetNext(Node);
  end;
  GlobalModule.IniStorage.Flush;
end;


//----------------------------------------
// m[hj
//----------------------------------------
procedure TKeyBindDlg.ActionTreeViewFreeNode(Sender: TBaseVirtualTree;
  Node: PVirtualNode);
var
  NodeData: PBindData;
begin
  NodeData := Sender.GetNodeData(Node);
  NodeData.Caption := '';
  NodeData.Action := '';
  NodeData.Shortcut := '';
end;

//----------------------------------------
// tH[j
//----------------------------------------
procedure TKeyBindDlg.FormDestroy(Sender: TObject);
begin
  ActionTreeView.Clear;
end;

//----------------------------------------
// m[h
//----------------------------------------
procedure TKeyBindDlg.ActionTreeViewInitNode(Sender: TBaseVirtualTree;
  ParentNode, Node: PVirtualNode;
  var InitialStates: TVirtualNodeInitStates);
//var
//  NodeData: PBindData;
begin
  //NodeData := Sender.GetNodeData(Node);
  if Sender.GetNodeLevel(Node) = 0 then
  begin
     InitialStates := InitialStates + [ivsHasChildren];
  end;
end;


end.
