unit DlgSetting;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, JvComponent, JvAppStorage, JvAppIniStorage,
  JvExStdCtrls, JvCombobox, JvColorCombo, AppEvnts, Mask, JvExMask, JvSpin,
  JvComponentBase;

type
  TSettingDlg = class(TForm)
    ButtonOK: TButton;
    ButtonCancel: TButton;
    PageControl: TPageControl;
    TabSheetEditor: TTabSheet;
    TabSheetTree: TTabSheet;
    IniStorage: TJvAppIniFileStorage;
    FontDialog: TFontDialog;
    TabSheetGeneral: TTabSheet;
    ApplicationEvents: TApplicationEvents;
    CheckBoxTreeEdit: TCheckBox;
    Label2: TLabel;
    SpinIndent: TJvSpinEdit;
    CheckBoxFreeSelect: TCheckBox;
    CheckBoxWarning: TCheckBox;
    CheckBoxAutoOpen: TCheckBox;
    CheckBoxRestoreTree: TCheckBox;
    CheckBoxImeMode: TCheckBox;
    CheckBoxSnapRuler: TCheckBox;
    Label3: TLabel;
    LabelFont: TLabel;
    ButtonFont: TButton;
    CheckBoxWordWrap: TCheckBox;
    CheckBoxInplaceEditOLE: TCheckBox;
    MarkGroupBox: TGroupBox;
    CheckBoxShowEOF: TCheckBox;
    CheckBoxShowTab: TCheckBox;
    CheckBoxShowEnter: TCheckBox;
    CheckBoxShowSpace: TCheckBox;
    EOFColorComboBox: TJvColorComboBox;
    TabColorComboBox: TJvColorComboBox;
    EnterColorComboBox: TJvColorComboBox;
    SpaceColorComboBox: TJvColorComboBox;
    CheckBoxTab: TCheckBox;
    CheckBoxUseMemory: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ButtonFontClick(Sender: TObject);
    procedure ButtonOKClick(Sender: TObject);
    procedure ApplicationEventsIdle(Sender: TObject; var Done: Boolean);
  private
    { Private 錾 }
    FFont: TFont;
  public
    { Public 錾 }
  end;

var
  SettingDlg: TSettingDlg;

implementation

uses
  Ruler, ModuleGlobal;

{$R *.dfm}


//----------------------------------------
// tH[̏
//----------------------------------------
procedure TSettingDlg.FormCreate(Sender: TObject);
var
  FStyle:TFontStyles;
  Fs :Byte absolute FStyle;
begin
  FFont := TFont.Create;

  // Sʐݒǂݍ
  IniStorage.Path := 'General';
  begin
    CheckBoxAutoOpen.Checked := IniStorage.ReadBoolean('AutoOpen', False);
    CheckBoxRestoreTree.Checked := IniStorage.ReadBoolean('RestoreTree', False);
    CheckBoxImeMode.Checked := IniStorage.ReadBoolean('ImeMode', False);
    CheckBoxUseMemory.Checked := IniStorage.ReadBoolean('UseMemory', False);
  end;

  // GfB^ݒǂݍ
  IniStorage.Path := 'Editor';
  begin
    // ڐPʓǂݍ 1.02Ŕp~
    //case  TRulerUnits(IniStorage.ReadInteger('Unit', Integer(ruCentimeters))) of
    //  ruCentimeters: ComboBoxUnit.ItemIndex := 0;
    //  ruMillimeters: ComboBoxUnit.ItemIndex := 1;
    //  ruInches: ComboBoxUnit.ItemIndex := 2;
    //else
    //  ComboBoxUnit.ItemIndex := 0;
    //end;

    // ڐɍ킹邩ǂǂݍ
    CheckBoxSnapRuler.Checked := IniStorage.ReadBoolean('SnapRuler', True);

    // TABL[œ͂邩ǂǂݍ 1.02
    CheckBoxTab.Checked := IniStorage.ReadBoolean('TabInput', False);

    // tHgݒǂݍ
    FFont.Name := IniStorage.ReadString('FontName', DEFAULT_FONT_NAME);
    FFont.Size := IniStorage.ReadInteger('FontSize', DEFAULT_FONT_SIZE);
    FFont.Color := IniStorage.ReadInteger('FontColor', DEFAULT_FONT_COLOR);
    Fs := IniStorage.ReadInteger('FontStyle', 0);
    FFont.Style := FStyle;

    LabelFont.Font.Assign(FFont);
    LabelFont.Font.Size := 9;
    LabelFont.Caption := FFont.Name + ' ' + IntToStr(FFont.Size) + 'pt';

    // [hbvǂݍ
    CheckBoxWordWrap.Checked := IniStorage.ReadBoolean('WordWrap', True);

    // OLEIuWFNgҏWݒǂݍ
    CheckBoxInplaceEditOLE.Checked := IniStorage.ReadBoolean('InplaceEditOLE', False);

    // ꕶ\ݒǂݍ
    CheckBoxShowEOF.Checked := IniStorage.ReadBoolean('ShowEOF', False);
    CheckBoxShowTab.Checked := IniStorage.ReadBoolean('ShowTab', False);
    CheckBoxShowEnter.Checked := IniStorage.ReadBoolean('ShowEnter', False);
    CheckBoxShowSpace.Checked := IniStorage.ReadBoolean('ShowSpace', False);

    EOFColorComboBox.ColorValue := IniStorage.ReadInteger('EOFColor', clGray);
    TabColorComboBox.ColorValue := IniStorage.ReadInteger('TabColor', clGray);
    EnterColorComboBox.ColorValue := IniStorage.ReadInteger('EnterColor', clGray);
    SpaceColorComboBox.ColorValue := IniStorage.ReadInteger('SpaceColor', clGray);
  end;

  // c[ݒǂݍ
  IniStorage.Path := 'Tree';
  begin
    CheckBoxTreeEdit.Checked := IniStorage.ReadBoolean('TreeEdit', True);

    SpinIndent.Value := IniStorage.ReadInteger('Indent', 18);

    CheckBoxFreeSelect.Checked := IniStorage.ReadBoolean('FreeSelect', False);

    CheckBoxWarning.Checked := IniStorage.ReadBoolean('Warning', True);
  end;

end;


//----------------------------------------
// tH[ǰ㏈
//----------------------------------------
procedure TSettingDlg.FormDestroy(Sender: TObject);
begin
  FFont.Free;
end;


//----------------------------------------
// tHgݒ
//----------------------------------------
procedure TSettingDlg.ButtonFontClick(Sender: TObject);
begin
  FontDialog.Font.Assign(FFont);
  if FontDialog.Execute then
  begin
    FFont.Assign(FontDialog.Font);
    LabelFont.Font.Assign(FFont);
    LabelFont.Font.Size := 9;
    LabelFont.Caption := FFont.Name + ' ' + IntToStr(FFont.Size) + 'pt';
  end;
end;


//----------------------------------------
// OK{^
//----------------------------------------
procedure TSettingDlg.ButtonOKClick(Sender: TObject);
var
  FStyle:TFontStyles;
  Fs :Byte absolute FStyle;
begin
  // Sʐݒ菑1
  IniStorage.Path := 'General';
  begin
    IniStorage.WriteBoolean('AutoOpen', CheckBoxAutoOpen.Checked);
    IniStorage.WriteBoolean('RestoreTree', CheckBoxRestoreTree.Checked);
    IniStorage.WriteBoolean('ImeMode', CheckBoxImeMode.Checked);
    IniStorage.WriteBoolean('UseMemory', CheckBoxUseMemory.Checked);
  end;

  // GfB^ݒ菑
  IniStorage.Path := 'Editor';
  begin
    // ڐPʏ 1.02Ŕp~
    //case  ComboBoxUnit.ItemIndex of
    //  0: IniStorage.WriteInteger('Unit', Integer(ruCentimeters));
    //  1: IniStorage.WriteInteger('Unit', Integer(ruMillimeters));
    //  2: IniStorage.WriteInteger('Unit', Integer(ruInches));
    //else
    //  IniStorage.WriteInteger('Unit', Integer(ruCentimeters));
    //end;

    // ڐɍ킹邩ǂ
    IniStorage.WriteBoolean('SnapRuler', CheckBoxSnapRuler.Checked);

    // TABL[œ͂邩ǂ 1.02
    IniStorage.WriteBoolean('TabInput', CheckBoxTab.Checked);

    // tHgݒ菑
    IniStorage.WriteString('FontName', FFont.Name);
    IniStorage.WriteInteger('FontSize', FFont.Size);
    IniStorage.WriteInteger('FontColor', FFont.Color);
    FStyle := FFont.Style;
    IniStorage.WriteInteger('FontStyle', Fs);

    // [hbv
    IniStorage.WriteBoolean('WordWrap', CheckBoxWordWrap.Checked);

    // OLEIuWFNgҏWݒ菑
    IniStorage.WriteBoolean('InplaceEditOLE', CheckBoxInplaceEditOLE.Checked);

    // ꕶ\ݒ菑
    IniStorage.WriteBoolean('ShowEOF', CheckBoxShowEOF.Checked);
    IniStorage.WriteBoolean('ShowTab', CheckBoxShowTab.Checked);
    IniStorage.WriteBoolean('ShowEnter', CheckBoxShowEnter.Checked);
    IniStorage.WriteBoolean('ShowSpace', CheckBoxShowSpace.Checked);

    IniStorage.WriteInteger('EOFColor', EOFColorComboBox.ColorValue);
    IniStorage.WriteInteger('TabColor', TabColorComboBox.ColorValue);
    IniStorage.WriteInteger('EnterColor', EnterColorComboBox.ColorValue);
    IniStorage.WriteInteger('SpaceColor', SpaceColorComboBox.ColorValue);
  end;

  // c[ݒ菑
  IniStorage.Path := 'Tree';
  begin
    IniStorage.WriteBoolean('TreeEdit', CheckBoxTreeEdit.Checked);

    IniStorage.WriteInteger('Indent',  Trunc(SpinIndent.Value));

    IniStorage.WriteBoolean('FreeSelect', CheckBoxFreeSelect.Checked);

    IniStorage.WriteBoolean('Warning', CheckBoxWarning.Checked);
  end;

  IniStorage.Flush;
end;


//----------------------------------------
// AChɃRg[̗L/
//----------------------------------------
procedure TSettingDlg.ApplicationEventsIdle(Sender: TObject;
  var Done: Boolean);
begin
  EOFColorComboBox.Enabled := CheckBoxShowEOF.Checked;
  TabColorComboBox.Enabled := CheckBoxShowTab.Checked;
  EnterColorComboBox.Enabled := CheckBoxShowEnter.Checked;
  SpaceColorComboBox.Enabled := CheckBoxShowSpace.Checked;
end;


end.
